import { DocumentNode } from "graphql";
export declare type Config = {
    graphql?: boolean;
    rest?: boolean;
    schema?: DocumentNode;
};
export declare type KeyValueString = {
    [key: string]: string;
};
export declare type KeyValueUnknown = {
    [key: string]: unknown;
};
export declare type UrlResolver = (params?: KeyValueString, collection?: boolean) => string;
export declare type ResolvingRESTOptions = {
    method: string;
    url: string | UrlResolver;
    params: unknown;
};
export declare type PropertyFunction<T> = () => T;
export declare type HttpMethod = 'get' | 'post' | 'put' | 'delete' | 'patch';
export declare type GraphQLErrorType = {
    extensions: {
        errorCode: number;
        message: string;
    };
};
export declare type GraphQLErrorBag = {
    graphQLErrors: GraphQLErrorType[];
};
export declare type EventType = {
    type: string;
    target: unknown;
    payload?: unknown;
};
export declare type EventSubscriber = {
    fired?: boolean;
    immediate: boolean;
    callback: (event: EventType) => void;
};
export declare type EventListeners = {
    [key: string]: EventSubscriber[];
};
//# sourceMappingURL=typings.d.ts.map